{
 open MiniProlog
 open MiniPrologParser
 exception Eof
} 
let lowercase = ['a'-'z']
let uppercase = ['A'-'Z']
let identchar = 
  ['A'-'Z' 'a'-'z' '_' '0'-'9']

rule token = parse
  [' ' '\t' '\n'] { token lexbuf }
| '.' { PERIOD }
| ',' { COMMA }
| '(' { LPAREN }
| ')' { RPAREN }
| "?-" { QHYPHEN }
| ":-" { CHYPHEN }
| lowercase identchar * { LIDENT(Lexing.lexeme lexbuf) }
| uppercase identchar * { CIDENT(Lexing.lexeme lexbuf) }
| '_' { CIDENT("_") }
| '\000' { EOF }
| eof { failwith "EOF" }


